"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Generated by CoffeeScript 2.7.0
(function () {
  var DelayObserver,
      Promise,
      RedisObserver,
      _,
      high,
      huge,
      mild,
      minimal,
      moderate,
      moment,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  _ = require("lodash");

  moment = require("moment");

  Promise = require("bluebird");

  RedisObserver = require("./redis.observer");

  var _require = require("./delay.levels");

  minimal = _require.minimal;
  mild = _require.mild;
  moderate = _require.moderate;
  high = _require.high;
  huge = _require.huge;


  module.exports = DelayObserver = function () {
    var DelayObserver = function (_RedisObserver) {
      _inherits(DelayObserver, _RedisObserver);

      function DelayObserver(_ref) {
        var redis = _ref.redis,
            app = _ref.app,
            path = _ref.path;

        _classCallCheck(this, DelayObserver);

        var _this = _possibleConstructorReturn(this, (DelayObserver.__proto__ || Object.getPrototypeOf(DelayObserver)).call(this, { redis: redis }));

        _this.finish = _this.finish.bind(_this);
        _this._messageDelay = _this._messageDelay.bind(_this);
        _this._millisecondsDelay = _this._millisecondsDelay.bind(_this);
        _this._delayChanged = _this._delayChanged.bind(_this);
        _this._delayByMilliseconds = _this._delayByMilliseconds.bind(_this);
        _this.app = app;
        _this.path = path;
        _this.currentDelay = minimal;
        return _this;
      }

      _createClass(DelayObserver, [{
        key: "listenTo",
        value: function listenTo(emitter) {
          return emitter.on("finished", this.finish);
        }
      }, {
        key: "finish",
        value: function finish(_ref2) {
          var notification = _ref2.notification;

          var delay;
          boundMethodCheck(this, DelayObserver);
          delay = this._messageDelay(notification);
          if (!(delay != null && this._delayChanged(delay))) {
            return Promise.resolve();
          }
          this.currentDelay = delay;
          return this.publish(notification, this.currentDelay.name);
        }
      }, {
        key: "_messageDelay",
        value: function _messageDelay(_ref3) {
          var meta = _ref3.meta;

          boundMethodCheck(this, DelayObserver);
          return this._delayByMilliseconds(this._millisecondsDelay(meta, new Date()));
        }
      }, {
        key: "_millisecondsDelay",
        value: function _millisecondsDelay(_ref4, now) {
          var insertionTime = _ref4.insertionTime;

          var enqueuedTime;
          boundMethodCheck(this, DelayObserver);
          enqueuedTime = moment.utc(new Date(insertionTime));
          return moment.utc(now).diff(enqueuedTime);
        }
      }, {
        key: "_delayChanged",
        value: function _delayChanged(newDelay) {
          boundMethodCheck(this, DelayObserver);
          return !_.isEqual(newDelay, this.currentDelay);
        }
      }, {
        key: "_delayByMilliseconds",
        value: function _delayByMilliseconds(ms) {
          var delayLevels;
          boundMethodCheck(this, DelayObserver);
          delayLevels = [minimal, mild, moderate, high, huge];
          return _.findLast(delayLevels, function (_ref5) {
            var value = _ref5.value;

            return ms >= value;
          });
        }
      }, {
        key: "_messagePath_",
        value: function _messagePath_() {
          return this.app + "/" + this.path;
        }
      }, {
        key: "_channelPrefix_",
        value: function _channelPrefix_(type) {
          return "health-delay-" + type;
        }
      }]);

      return DelayObserver;
    }(RedisObserver);

    ;

    DelayObserver.prototype._buildValue_ = _.identity;

    return DelayObserver;
  }.call(this);
}).call(undefined);