"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Generated by CoffeeScript 2.7.0
(function () {
  var DidLastRetry,
      Promise,
      RedisObserver,
      _,
      errorToJson,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  _ = require("lodash");

  Promise = require("bluebird");

  RedisObserver = require("./redis.observer");

  errorToJson = require("error-to-json");

  module.exports = DidLastRetry = function () {
    var DidLastRetry = function (_RedisObserver) {
      _inherits(DidLastRetry, _RedisObserver);

      function DidLastRetry(_ref) {
        var redis = _ref.redis,
            app = _ref.app,
            path = _ref.path,
            _ref$maxDeliveryCount = _ref.maxDeliveryCount,
            maxDeliveryCount = _ref$maxDeliveryCount === undefined ? 5 : _ref$maxDeliveryCount,
            sender = _ref.sender;

        _classCallCheck(this, DidLastRetry);

        var _this = _possibleConstructorReturn(this, (DidLastRetry.__proto__ || Object.getPrototypeOf(DidLastRetry)).call(this, { redis: redis }));

        _this.listenTo = _this.listenTo.bind(_this);
        _this.error = _this.error.bind(_this);
        _this._messagePath_ = _this._messagePath_.bind(_this);
        _this._channelPrefix_ = _this._channelPrefix_.bind(_this);
        _this.app = app;
        _this.path = path;
        _this.maxDeliveryCount = maxDeliveryCount;
        _this.sender = sender;
        return _this;
      }

      _createClass(DidLastRetry, [{
        key: "listenTo",
        value: function listenTo(observable) {
          boundMethodCheck(this, DidLastRetry);
          return observable.on("unsuccessful", this.error);
        }
      }, {
        key: "error",
        value: function error(_ref2) {
          var notification = _ref2.notification,
              _error = _ref2.error;

          boundMethodCheck(this, DidLastRetry);
          if (notification.meta.dequeueCount >= this.maxDeliveryCount) {
            if (!_.isString(_error)) {
              _error = errorToJson(_error);
            }
            return this.publish(notification, {
              success: false,
              value: { error: _error }
            });
          } else {
            return Promise.resolve();
          }
        }
      }, {
        key: "_messagePath_",
        value: function _messagePath_(notification) {
          var _this2 = this;

          boundMethodCheck(this, DidLastRetry);
          return Promise.props({
            user: this.sender.user(notification),
            resource: this.sender.resource(notification)
          }).then(function (_ref3) {
            var user = _ref3.user,
                resource = _ref3.resource;

            return _this2.app + "/" + user + "/" + _this2.path + "/" + resource;
          });
        }
      }, {
        key: "_channelPrefix_",
        value: function _channelPrefix_(type) {
          boundMethodCheck(this, DidLastRetry);
          return "health-message-" + type;
        }
      }]);

      return DidLastRetry;
    }(RedisObserver);

    ;

    DidLastRetry.prototype._buildValue_ = JSON.stringify;

    return DidLastRetry;
  }.call(this);
}).call(undefined);