"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Generated by CoffeeScript 2.7.0
(function () {
  var IncidentsApiObserver, Promise, ServiceBusClient, _, debug, encode;

  _ = require("lodash");

  Promise = require("bluebird");

  var _require = require("@azure/service-bus");

  ServiceBusClient = _require.ServiceBusClient;

  var _require2 = require("url-safe-base64");

  encode = _require2.encode;


  debug = require("debug")("notification-processor:observers:incidents-api");

  module.exports = IncidentsApiObserver = function () {
    function IncidentsApiObserver(_ref) {
      var sender = _ref.sender,
          clientId = _ref.clientId,
          app = _ref.app,
          job = _ref.job,
          _ref$propertiesToOmit = _ref.propertiesToOmit,
          propertiesToOmit = _ref$propertiesToOmit === undefined ? "auth" : _ref$propertiesToOmit,
          _ref$connection = _ref.connection,
          connectionString = _ref$connection.connectionString,
          topic = _ref$connection.topic;

      _classCallCheck(this, IncidentsApiObserver);

      this.publishToTopic = this.publishToTopic.bind(this);
      this.sender = sender;
      this.clientId = clientId;
      this.app = app;
      this.job = job;
      this.propertiesToOmit = propertiesToOmit;
      this.messageSender = this._buildMessageSender(connectionString, topic);
    }

    _createClass(IncidentsApiObserver, [{
      key: "listenTo",
      value: function listenTo(observable) {
        return observable.on("unsuccessful_non_retryable", this.publishToTopic);
      }
    }, {
      key: "publishToTopic",
      value: function publishToTopic(_ref2) {
        var _this = this;

        var id = _ref2.id,
            notification = _ref2.notification,
            error = _ref2.error;

        var $message;
        $message = Promise.props({
          body: this._mapper(id, notification, error.cause)
        });
        return $message.tap(function (message) {
          return debug("To publish message %o", message);
        }).then(function (message) {
          return _this.messageSender.send(message);
        });
      }
    }, {
      key: "_mapper",
      value: function _mapper(id, notification, err) {
        var _this2 = this;

        return Promise.props({
          resource: Promise.method(this.sender.resource)(notification),
          user: Promise.method(this.sender.user)(notification)
        }).then(function (_ref3) {
          var resource = _ref3.resource,
              user = _ref3.user;

          return {
            id: encode([_this2.app, _this2.job, resource].join("_")),
            app: _this2.app,
            job: _this2.job,
            resource: "" + resource,
            notification: notification,
            user: "" + user,
            clientId: _this2.clientId,
            error: _.omit(err, "detail.request"),
            request: _.omit(_.get(err, "detail.request"), _this2.propertiesToOmit),
            type: _.get(err, "type", "unknown_error"),
            tags: _.get(err, "tags", [])
          };
        }).then(JSON.stringify);
      }
    }, {
      key: "_buildMessageSender",
      value: function _buildMessageSender(connectionString, topic) {
        return ServiceBusClient.createFromConnectionString(connectionString).createQueueClient(topic).createSender();
      }
    }]);

    return IncidentsApiObserver;
  }();
}).call(undefined);