"use strict";

// Generated by CoffeeScript 2.7.0
(function () {
  var errorToJson;

  errorToJson = require("error-to-json");

  module.exports = {
    listenTo: function listenTo(observable) {
      observable.on("started", function (_ref) {
        var log = _ref.context.log,
            notification = _ref.notification,
            id = _ref.id;

        return log.info("A new message has been received", {
          id: id,
          notification: JSON.stringify(notification)
        });
      });
      observable.on("successful", function (_ref2) {
        var log = _ref2.context.log,
            id = _ref2.id;

        return log.info("The process was successful", { id: id });
      });
      observable.on("unsuccessful", function (_ref3) {
        var log = _ref3.context.log,
            id = _ref3.id,
            notification = _ref3.notification,
            error = _ref3.error;

        return log.error("The process was unsuccessful", {
          id: id,
          notification: JSON.stringify(notification),
          error: JSON.stringify(errorToJson(error))
        });
      });
      observable.on("unsuccessful_non_retryable", function (_ref4) {
        var log = _ref4.context.log,
            id = _ref4.id,
            notification = _ref4.notification,
            error = _ref4.error;

        return log.error("The process was unsuccessful but it can't be retried", {
          id: id,
          notification: JSON.stringify(notification),
          error: JSON.stringify(errorToJson(error))
        });
      });
      return observable.on("ignored", function (_ref5) {
        var log = _ref5.context.log,
            id = _ref5.id;

        return log.verbose("The message was ignored", { id: id });
      });
    }
  };
}).call(undefined);