"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Generated by CoffeeScript 2.7.0
(function () {
  var Promise, Redis, RedisObserver, _;

  _ = require("lodash");

  Redis = require("../services/redis");

  Promise = require("bluebird");

  module.exports = RedisObserver = function () {
    function RedisObserver(_ref) {
      var _ref$redis = _ref.redis,
          redis = _ref$redis === undefined ? {} : _ref$redis;

      _classCallCheck(this, RedisObserver);

      this.publish = this.publish.bind(this);
      this._getChannel = this._getChannel.bind(this);
      this._messagePath_ = this._messagePath_.bind(this);
      this._buildValue_ = this._buildValue_.bind(this);
      this._channelPrefix_ = this._channelPrefix_.bind(this);
      _.defaults(redis, {
        host: process.env.REDIS_HOST,
        port: process.env.REDIS_PORT,
        db: process.env.REDIS_DB,
        auth: process.env.REDIS_AUTH
      });
      this.redis = Redis.createClient(redis.port, redis.host, {
        db: redis.db
      });
      if (redis.auth) {
        this.redis.auth(redis.auth);
      }
    }

    _createClass(RedisObserver, [{
      key: "publish",
      value: function publish(notification, value) {
        var _this = this;

        return Promise.props({
          channel: this._getChannel(notification),
          value: this._buildValue_(value)
        }).then(function (_ref2) {
          var channel = _ref2.channel,
              value = _ref2.value;

          return _this.redis.publishAsync(channel, value);
        });
      }
    }, {
      key: "_getChannel",
      value: function _getChannel(notification) {
        return Promise.props({
          channelPrefix: this._channelPrefix_(notification.type),
          messagePath: this._messagePath_(notification)
        }).then(function (_ref3) {
          var channelPrefix = _ref3.channelPrefix,
              messagePath = _ref3.messagePath;

          return channelPrefix + "/" + messagePath;
        });
      }
    }, {
      key: "_messagePath_",
      value: function _messagePath_() {
        throw new Error("not supported `_messagePath_`");
      }
    }, {
      key: "_buildValue_",
      value: function _buildValue_() {
        throw new Error("not supported `_buildValue_`");
      }
    }, {
      key: "_channelPrefix_",
      value: function _channelPrefix_(type) {
        throw new Error("not supported `_channelPrefix_`");
      }
    }]);

    return RedisObserver;
  }();
}).call(undefined);