"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Generated by CoffeeScript 2.7.0
(function () {
  var ENABLE_EVENTS,
      EventEmitter,
      IgnoredError,
      NonRetryable,
      Processor,
      Promise,
      _,
      newrelic,
      uuid,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  };

  _ = require("lodash");

  NonRetryable = require("./exceptions/non.retryable");

  IgnoredError = require("./exceptions/ignored.error");

  EventEmitter = require("events");

  Promise = require("bluebird");

  uuid = require("uuid/v4");

  newrelic = _.once(function () {
    return require("newrelic");
  });

  ENABLE_EVENTS = process.env.ENABLE_EVENTS !== "false";

  module.exports = Processor = function (_EventEmitter) {
    _inherits(Processor, _EventEmitter);

    function Processor(_ref) {
      var source = _ref.source,
          runner = _ref.runner,
          timeout = _ref.timeout,
          apm = _ref.apm;

      _classCallCheck(this, Processor);

      var _this = _possibleConstructorReturn(this, (Processor.__proto__ || Object.getPrototypeOf(Processor)).call(this));

      _this.process = _this.process.bind(_this);
      _this._emitEvent = _this._emitEvent.bind(_this);
      _this.source = source;
      _this.runner = runner;
      _this.timeout = timeout;
      _this.apm = apm;
      return _this;
    }

    _createClass(Processor, [{
      key: "process",
      value: function process(context, raw) {
        var _this2 = this;

        var $promise, _isIgnoredError, execute, id, notification;
        boundMethodCheck(this, Processor);
        id = uuid();
        notification = this.source.newNotification({
          context: context,
          id: id,
          message: raw
        });
        this._emitEvent("started", { context: context, id: id, notification: notification });
        $promise = Promise.method(this.runner)(notification, context, id);
        if (this.timeout != null) {
          $promise = $promise.timeout(this.timeout, "processor timeout");
        }
        execute = function execute() {
          var ref;
          if (!((ref = _this2.apm) != null ? ref.active : void 0)) {
            return $promise;
          }
          return newrelic().startBackgroundTransaction(_this2.apm.transactionName, _this2.apm.group, function () {
            return $promise.tapCatch(function (err) {
              return newrelic().noticeError(new Error(JSON.stringify(_.omit(err.detail, "request.auth.pass"))));
            });
          });
        };
        _isIgnoredError = function _isIgnoredError(error) {
          return error instanceof IgnoredError;
        };
        execute().tap(function () {
          return _this2._emitEvent("successful", { context: context, id: id, notification: notification });
        }).catch(_isIgnoredError, function (error) {
          return _this2._emitEvent("successful", {
            context: context,
            id: id,
            notification: notification,
            warnings: [error]
          });
        }).catch(function (error) {
          if (!(error instanceof NonRetryable)) {
            throw error;
          }
          return _this2._emitEvent("unsuccessful_non_retryable", { context: context, id: id, notification: notification, error: error });
        }).tapCatch(function (error) {
          return _this2._emitEvent("unsuccessful", { context: context, id: id, notification: notification, error: error });
        }).finally(function () {
          return _this2._emitEvent("finished", { context: context, id: id, notification: notification });
        }).asCallback(context.done);
      }
    }, {
      key: "_emitEvent",
      value: function _emitEvent(eventName, value) {
        boundMethodCheck(this, Processor);
        if (ENABLE_EVENTS) {
          return this.emit(eventName, value);
        }
      }
    }]);

    return Processor;
  }(EventEmitter);
}).call(undefined);