"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Generated by CoffeeScript 2.7.0
(function () {
  var JobProcessor,
      MaxRetriesProcessor,
      NonRetryable,
      NotificationsApi,
      _,
      debug,
      request,
      boundMethodCheck = function boundMethodCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new Error('Bound instance method accessed before binding');
    }
  },
      indexOf = [].indexOf;

  _ = require("lodash");

  request = require("request-promise");

  MaxRetriesProcessor = require("../maxRetries.processor");

  NonRetryable = require("../../exceptions/non.retryable");

  NotificationsApi = require("./notification.api");

  debug = require("debug")("notification-processor:job-processor");

  module.exports = JobProcessor = function (_MaxRetriesProcessor) {
    _inherits(JobProcessor, _MaxRetriesProcessor);

    function JobProcessor(args) {
      _classCallCheck(this, JobProcessor);

      var _this = _possibleConstructorReturn(this, (JobProcessor.__proto__ || Object.getPrototypeOf(JobProcessor)).call(this, args));

      _this.process = _this.process.bind(_this);
      _this._onSuccess_ = _this._onSuccess_.bind(_this);
      _this._shouldRetry_ = _this._shouldRetry_.bind(_this);
      _this._sanitizeError_ = _this._sanitizeError_.bind(_this);
      _this._onMaxRetryExceeded_ = _this._onMaxRetryExceeded_.bind(_this);
      _this._notificationsApi = _this._notificationsApi.bind(_this);
      _this._ifJobIsNotStopped = _this._ifJobIsNotStopped.bind(_this);
      _this.notificationApiUrl = args.notificationApiUrl;
      _this.notificationApiAsyncUrl = args.notificationApiAsyncUrl;
      _this.nonRetryable = args.nonRetryable;
      _this.silentErrors = args.silentErrors;
      return _this;
    }

    _createClass(JobProcessor, [{
      key: "process",
      value: function process(notification, context, executionId) {
        var _this2 = this;

        boundMethodCheck(this, JobProcessor);
        return this._ifJobIsNotStopped(notification.message, function () {
          return _get(JobProcessor.prototype.__proto__ || Object.getPrototypeOf(JobProcessor.prototype), "process", _this2).call(_this2, notification, context, executionId).thenReturn();
        });
      }
    }, {
      key: "_onSuccess_",
      value: function _onSuccess_(_ref, _ref2) {
        var _this3 = this;

        var message = _ref.message;
        var statusCode = _ref2.statusCode;

        boundMethodCheck(this, JobProcessor);
        return this._ifJobIsNotStopped(message, function () {
          return _this3._notificationsApi(message).success({ message: message, statusCode: statusCode });
        });
      }
    }, {
      key: "_shouldRetry_",
      value: function _shouldRetry_(notification, err) {
        var ref, ref1, ref2;
        boundMethodCheck(this, JobProcessor);
        return _get(JobProcessor.prototype.__proto__ || Object.getPrototypeOf(JobProcessor.prototype), "_shouldRetry_", this).call(this, notification, err) && (ref = err != null ? (ref1 = err.detail) != null ? (ref2 = ref1.response) != null ? ref2.statusCode : void 0 : void 0 : void 0, indexOf.call(this.nonRetryable, ref) < 0);
      }
    }, {
      key: "_sanitizeError_",
      value: function _sanitizeError_(err) {
        boundMethodCheck(this, JobProcessor);
        return _.pick(err, ["statusCode", "error"]);
      }
    }, {
      key: "_onMaxRetryExceeded_",
      value: function _onMaxRetryExceeded_(_ref3, error) {
        var _this4 = this;

        var message = _ref3.message;

        var errorMessage;
        boundMethodCheck(this, JobProcessor);
        errorMessage = {
          message: message,
          statusCode: error.detail.response.statusCode,
          error: error,
          request: _.omit(error.detail.request, ["resolveWithFullResponse"])
        };
        return this._ifJobIsNotStopped(message, function () {
          return _this4._notificationsApi(message).fail(errorMessage).throw(new NonRetryable("Max retry exceeded", error));
        });
      }
    }, {
      key: "_notificationsApi",
      value: function _notificationsApi(_ref4) {
        var HeadersForRequest = _ref4.HeadersForRequest,
            JobId = _ref4.JobId;

        boundMethodCheck(this, JobProcessor);
        return new NotificationsApi({
          token: _.find(HeadersForRequest, {
            Key: "Authorization"
          }).Value,
          jobId: JobId,
          notificationApiUrl: this.notificationApiUrl,
          notificationApiAsyncUrl: this.notificationApiAsyncUrl
        });
      }
    }, {
      key: "_ifJobIsNotStopped",
      value: function _ifJobIsNotStopped(message, action) {
        boundMethodCheck(this, JobProcessor);
        return this._notificationsApi(message).jobIsStopped().then(function (jobIsStopped) {
          if (jobIsStopped) {
            console.log("job " + message.JobId + " is stopped, ignoring action");
            return Promise.resolve();
          }
          return action();
        });
      }
    }]);

    return JobProcessor;
  }(MaxRetriesProcessor);
}).call(undefined);