"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Generated by CoffeeScript 2.7.0
(function () {
  var DEFAULT_NOTIFICATIONS_API_ASYNC_URL, DEFAULT_NOTIFICATIONS_API_URL, HOUR, NOTIFICATIONS_API_JOBS_CACHE_TTL, NOTIFICATIONS_API_MASTER_TOKEN, NOTIFICATIONS_API_STOPPED_JOB_CACHE_TTL, NodeCache, NotificationsApi, Promise, _, jobsCache, requestPromise, retry, stoppedJobsCache;

  _ = require("lodash");

  requestPromise = require("request-promise");

  retry = require("bluebird-retry");

  Promise = require("bluebird");

  NodeCache = require("node-cache");

  NOTIFICATIONS_API_JOBS_CACHE_TTL = parseInt(process.env.NOTIFICATIONS_API_JOBS_CACHE_TTL) || 5;

  NOTIFICATIONS_API_STOPPED_JOB_CACHE_TTL = parseInt(process.env.NOTIFICATIONS_API_STOPPED_JOB_CACHE_TTL) || 2;

  NOTIFICATIONS_API_MASTER_TOKEN = process.env.NOTIFICATIONS_API_MASTER_TOKEN;

  DEFAULT_NOTIFICATIONS_API_ASYNC_URL = process.env.DEFAULT_NOTIFICATIONS_API_ASYNC_URL || "https://apps.producteca.com/aws/notifications-api-async";

  DEFAULT_NOTIFICATIONS_API_URL = process.env.NOTIFICATIONS_API_URL || "https://apps.producteca.com/notifications-api/api";

  HOUR = 60 * 60;

  //Para minimizar las requests a notifications-api, cachea unos segundos el estado del job
  jobsCache = new NodeCache({
    stdTTL: NOTIFICATIONS_API_JOBS_CACHE_TTL
  });

  //A nivel dominio, podria ser cache sin TTL porque un job stoppeado queda asi para siempre. Pero se pone TTL de 2h para que luego libere la memoria
  stoppedJobsCache = new NodeCache({
    stdTTL: NOTIFICATIONS_API_STOPPED_JOB_CACHE_TTL * HOUR
  });

  NotificationsApi = function () {
    function NotificationsApi(_ref) {
      var _ref$notificationApiU = _ref.notificationApiUrl,
          notificationApiUrl = _ref$notificationApiU === undefined ? DEFAULT_NOTIFICATIONS_API_URL : _ref$notificationApiU,
          token1 = _ref.token,
          jobId1 = _ref.jobId,
          _ref$notificationApiA = _ref.notificationApiAsyncUrl,
          notificationApiAsyncUrl = _ref$notificationApiA === undefined ? DEFAULT_NOTIFICATIONS_API_ASYNC_URL : _ref$notificationApiA;

      _classCallCheck(this, NotificationsApi);

      var companyId;
      this.success = this.success.bind(this);
      this.fail = this.fail.bind(this);
      this.jobIsStopped = this.jobIsStopped.bind(this);
      this.jobName = this.jobName.bind(this);
      this._jobIsStopped = this._jobIsStopped.bind(this);
      this.fetchJob = this.fetchJob.bind(this);
      this._fetchJob = this._fetchJob.bind(this);
      this._doFetchJob = this._doFetchJob.bind(this);
      this._retryViaAsyncOrIgnore = this._retryViaAsyncOrIgnore.bind(this);
      this._makeRequest = this._makeRequest.bind(this);
      this._shouldUseCachedValue = this._shouldUseCachedValue.bind(this);
      this.notificationApiUrl = notificationApiUrl;
      this.token = token1;
      this.jobId = jobId1;
      this.notificationApiAsyncUrl = notificationApiAsyncUrl;
      if (_.startsWith(this.token, 'Basic') && !_.isEmpty(NOTIFICATIONS_API_MASTER_TOKEN)) {
        companyId = _.first(Buffer.from(_.get(this.token.split(" "), "1"), 'base64').toString().split(":"));
        this.token = "Basic " + new Buffer(companyId + ":" + NOTIFICATIONS_API_MASTER_TOKEN).toString("base64");
      }
    }

    _createClass(NotificationsApi, [{
      key: "success",
      value: function success(response, options) {
        var _this = this;

        var __makeRequest, __retryRequest, statusCode;
        statusCode = response.statusCode;

        __makeRequest = function __makeRequest() {
          return _this._makeRequest({
            statusCode: statusCode,
            success: true
          }, options);
        };
        __retryRequest = function __retryRequest() {
          return _this.success(response, {
            useAsyncApi: true
          });
        };
        return this._retryViaAsyncOrIgnore(__makeRequest, __retryRequest, options);
      }
    }, {
      key: "fail",
      value: function fail(response, options) {
        var _this2 = this;

        var __makeRequest, __retryRequest, error, message, request, statusCode;
        statusCode = response.statusCode;
        error = response.error;
        request = response.request;

        message = _.get(error, "message");
        error = _.get(error, "type");
        __makeRequest = function __makeRequest() {
          return _this2._makeRequest({
            statusCode: statusCode,
            success: false,
            message: message,
            error: error,
            request: request
          }, options);
        };
        __retryRequest = function __retryRequest() {
          return _this2.fail(response, {
            useAsyncApi: true
          });
        };
        return this._retryViaAsyncOrIgnore(__makeRequest, __retryRequest, options);
      }
    }, {
      key: "jobIsStopped",
      value: function jobIsStopped() {
        var _this3 = this;

        var cachedStoppedJob;
        cachedStoppedJob = stoppedJobsCache.get(this.jobId);
        if (this._shouldUseCachedValue(cachedStoppedJob)) {
          return Promise.resolve(cachedStoppedJob);
        }
        return this._jobIsStopped().tap(function (jobIsStopped) {
          if (jobIsStopped) {
            return stoppedJobsCache.set(_this3.jobId, jobIsStopped);
          }
        });
      }
    }, {
      key: "jobName",
      value: function jobName(jobId, token) {
        return this._fetchJob(jobId, token).then(function (job) {
          return job.name;
        });
      }
    }, {
      key: "_jobIsStopped",
      value: function _jobIsStopped(jobId, token) {
        return this._fetchJob(jobId, token).then(function (job) {
          return job.stopped;
        });
      }
    }, {
      key: "fetchJob",
      value: function fetchJob(aJobId, aToken) {
        return this._fetchJob(aJobId, aToken);
      }
    }, {
      key: "_fetchJob",
      value: function _fetchJob(aJobId, aToken) {
        var cachedJob, jobId;
        jobId = aJobId || this.jobId;
        cachedJob = jobsCache.get(jobId);
        if (this._shouldUseCachedValue(cachedJob)) {
          return Promise.resolve(cachedJob);
        }
        return this._doFetchJob(jobId, aToken).tap(function (job) {
          return jobsCache.set(jobId, job);
        });
      }
    }, {
      key: "_doFetchJob",
      value: function _doFetchJob(jobId, token) {
        var _this4 = this;

        var __fetchJob;
        __fetchJob = function __fetchJob() {
          return requestPromise({
            url: _this4.notificationApiUrl + "/jobs/" + (jobId || _this4.jobId),
            method: "GET",
            headers: {
              authorization: token || _this4.token
            },
            json: true
          }).promise();
        };
        return retry(__fetchJob, {
          throw_original: true
        });
      }
    }, {
      key: "_retryViaAsyncOrIgnore",
      value: function _retryViaAsyncOrIgnore(makeRequest, retryRequest) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

        return retry(makeRequest, {
          throw_original: true,
          max_tries: 3
        }).catch(function (e) {
          if (options.useAsyncApi) {
            throw e;
          }
          console.log("Error sending status to notifications-api. Retrying via notifications-api-async");
          return retryRequest();
        }).catchReturn();
      }
    }, {
      key: "_makeRequest",
      value: function _makeRequest(body) {
        var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
            useAsyncApi = _ref2.useAsyncApi;

        var url;
        url = useAsyncApi ? this.notificationApiAsyncUrl : this.notificationApiUrl;
        return requestPromise({
          url: url + "/jobs/" + this.jobId + "/operations",
          method: "POST",
          headers: {
            authorization: this.token
          },
          json: body
        });
      }
    }, {
      key: "_shouldUseCachedValue",
      value: function _shouldUseCachedValue(value) {
        return process.env.NODE_ENV !== "test" && value != null;
      }
    }]);

    return NotificationsApi;
  }();

  module.exports = NotificationsApi;
}).call(undefined);