"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Generated by CoffeeScript 2.7.0
(function () {
  var IgnoredError, MaxRetriesProcessor, Promise;

  Promise = require("bluebird");

  IgnoredError = require("../exceptions/ignored.error");

  module.exports = MaxRetriesProcessor = function () {
    function MaxRetriesProcessor(_ref) {
      var processor = _ref.processor,
          _ref$maxRetries = _ref.maxRetries,
          maxRetries = _ref$maxRetries === undefined ? 3 : _ref$maxRetries;

      _classCallCheck(this, MaxRetriesProcessor);

      this._onIgnoredError_ = this._onIgnoredError_.bind(this);
      this.processor = processor;
      this.maxRetries = maxRetries;
    }

    _createClass(MaxRetriesProcessor, [{
      key: "process",
      value: function process(notification, context, executionId) {
        var _this = this;

        return this.processor(notification, context, executionId).tap(function (it) {
          return _this._onSuccess_(notification, it);
        }).catch(function (err) {
          if (_this._isIgnoredError_(err)) {
            return _this._onIgnoredError_(notification, err);
          }
          if (_this._shouldRetry_(notification, err)) {
            throw _this._sanitizeError_(err);
          }
          return _this._onMaxRetryExceeded_(notification, err);
        });
      }
    }, {
      key: "_shouldRetry_",
      value: function _shouldRetry_(_ref2, err) {
        var _ref2$meta$dequeueCou = _ref2.meta.dequeueCount,
            dequeueCount = _ref2$meta$dequeueCou === undefined ? 0 : _ref2$meta$dequeueCou;

        return dequeueCount < this.maxRetries;
      }
    }, {
      key: "_onSuccess_",
      value: function _onSuccess_(notification, result) {
        throw new Error("subclass responsability");
      }
    }, {
      key: "_sanitizeError_",
      value: function _sanitizeError_(err) {
        throw new Error("subclass responsability");
      }
    }, {
      key: "_onMaxRetryExceeded_",
      value: function _onMaxRetryExceeded_(notification, err) {
        throw new Error("subclass responsability");
      }
    }, {
      key: "_onIgnoredError_",
      value: function _onIgnoredError_(notification, err) {
        var _this2 = this;

        return Promise.try(function () {
          return _this2._onSuccess_(notification, err);
        }).tap(function () {
          throw err;
        });
      }
    }, {
      key: "_isIgnoredError_",
      value: function _isIgnoredError_(err) {
        return err instanceof IgnoredError;
      }
    }]);

    return MaxRetriesProcessor;
  }();
}).call(undefined);