"use strict";

// Generated by CoffeeScript 2.7.0
(function () {
  var RequestProcessor, _, _normalizeHeaders, builderRequest;

  _ = require("lodash");

  RequestProcessor = require("./request.processor");

  _normalizeHeaders = function _normalizeHeaders(headers) {
    return _(headers).map(function (_ref) {
      var Key = _ref.Key,
          Value = _ref.Value;

      return [Key, Value];
    }).fromPairs().value();
  };

  builderRequest = function builderRequest(apiUrl, fullResponse) {
    return function (_ref2, context, executionId) {
      var message = _ref2.message;

      var Body, HeadersForRequest, JobId, Method, Resource, headers, json, url;
      Resource = message.Resource;
      Method = message.Method;
      Body = message.Body;
      HeadersForRequest = message.HeadersForRequest;
      JobId = message.JobId;

      json = (Body != null ? Body.length : void 0) > 0 ? JSON.parse(Body) : true;
      headers = _normalizeHeaders(HeadersForRequest);
      if (JobId) {
        headers['x-producteca-event-id'] = JobId + "/" + executionId;
      }
      url = headers.Domain || apiUrl;
      return {
        url: "" + url + Resource,
        method: Method,
        headers: headers,
        json: json,
        resolveWithFullResponse: fullResponse
      };
    };
  };

  module.exports = function (_ref3) {
    var apiUrl = _ref3.apiUrl,
        _ref3$fullResponse = _ref3.fullResponse,
        fullResponse = _ref3$fullResponse === undefined ? false : _ref3$fullResponse,
        silentErrors = _ref3.silentErrors,
        nonRetryable = _ref3.nonRetryable;

    return RequestProcessor(builderRequest(apiUrl, fullResponse), { silentErrors: silentErrors, nonRetryable: nonRetryable });
  };
}).call(undefined);