"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

// Generated by CoffeeScript 2.7.0
(function () {
  var NotificationsApi, OAuthApi, Promise, _, _companyId, _companyIdFromBasicToken, _headerValue, notificationsApi, retry, uuid;

  _ = require("lodash");

  OAuthApi = require("../services/oAuthApi");

  NotificationsApi = require("../processors/job/notification.api");

  Promise = require("bluebird");

  retry = require("bluebird-retry");

  uuid = require("uuid/v4");

  notificationsApi = new NotificationsApi({});

  _companyIdFromBasicToken = function _companyIdFromBasicToken(token) {
    var decoded;
    decoded = Buffer.from(token, "base64").toString();
    return _.split(decoded, ":")[0];
  };

  _companyId = function _companyId(method, token) {
    if (method !== "Basic") {
      return new OAuthApi(token).scopes().get("companyId");
    }
    return _companyIdFromBasicToken(token);
  };

  _headerValue = function _headerValue(headers, key, defaultValue) {
    var header;
    header = _.find(headers, {
      Key: key
    });
    return _.get(header, "Value", defaultValue);
  };

  module.exports = {
    user: function user(_ref) {
      var HeadersForRequest = _ref.message.HeadersForRequest;

      var method, token;

      var _headerValue$split = _headerValue(HeadersForRequest, "Authorization", "").split(" ");

      var _headerValue$split2 = _slicedToArray(_headerValue$split, 2);

      method = _headerValue$split2[0];
      token = _headerValue$split2[1];

      return _companyId(method, token);
    },
    resource: function resource(_ref2, resourceGetter) {
      var message = _ref2.message;

      if (_.isFunction(resourceGetter)) {
        return resourceGetter(message);
      } else {
        return _.get(message, "Resource");
      }
    },
    monitoringCenterFields: function monitoringCenterFields(notification) {
      var _this = this;

      var __job, __scopes, fullToken, method, token;
      fullToken = _headerValue(notification.message.HeadersForRequest, "Authorization", "");

      var _fullToken$split = fullToken.split(" ");

      var _fullToken$split2 = _slicedToArray(_fullToken$split, 2);

      method = _fullToken$split2[0];
      token = _fullToken$split2[1];

      __scopes = function __scopes() {
        if (_(method.toLowerCase()).includes("bearer")) {
          return retry(function () {
            return new OAuthApi(token).scopes();
          });
        }
        return Promise.resolve({
          id: null,
          appId: null,
          companyId: _companyIdFromBasicToken(token)
        });
      };
      __job = function __job() {
        if (notification.message.JobId && fullToken) {
          return notificationsApi.fetchJob(notification.message.JobId, fullToken).catchReturn().then(function (it) {
            return it || {};
          });
        } else {
          return Promise.resolve({});
        }
      };
      return Promise.props({
        scopes: __scopes(),
        job: __job()
      }).then(function (_ref3) {
        var _ref3$scopes = _ref3.scopes,
            id = _ref3$scopes.id,
            companyId = _ref3$scopes.companyId,
            appId = _ref3$scopes.appId,
            _ref3$job = _ref3.job,
            name = _ref3$job.name,
            creationDate = _ref3$job.creationDate;

        var eventId, headersWithoutAuth, jobCreationDate, messageInsertionTime, ref, ref1, ref2;
        eventId = notification.message.JobId || _headerValue(notification.message.HeadersForRequest, "x-producteca-event-id", null) || _headerValue(notification.message.HeadersForRequest, "X-producteca-event-id", null) || (notification != null ? (ref = notification.meta) != null ? ref.messageId : void 0 : void 0) || uuid();
        if (creationDate) {
          jobCreationDate = new Date(creationDate).getTime();
        }
        if (notification != null ? (ref1 = notification.meta) != null ? ref1.insertionTime : void 0 : void 0) {
          messageInsertionTime = new Date(notification != null ? (ref2 = notification.meta) != null ? ref2.insertionTime : void 0 : void 0).getTime();
        }
        headersWithoutAuth = _.reject(notification.message.HeadersForRequest, function (_ref4) {
          var Key = _ref4.Key;

          return (Key != null ? Key.toLowerCase() : void 0) === 'authorization';
        });
        return Promise.props({
          eventType: 'http',
          resource: _this.resource(notification),
          companyId: companyId,
          userId: id,
          app: parseInt(appId),
          job: name,
          externalReference: null,
          eventId: eventId,
          eventTimestamp: jobCreationDate || messageInsertionTime,
          parentEventId: null,
          partialMessage: _.assign({}, notification.message, {
            HeadersForRequest: headersWithoutAuth
          })
        });
      });
    }
  };
}).call(undefined);