"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Generated by CoffeeScript 2.7.0
(function () {
  var MERCADOLIBRE_API_CORE_URL, MERCADOLIBRE_API_MASTER_TOKEN, NodeCache, Promise, UserIdTranslator, _, request, retry, translatedCache;

  _ = require("lodash");

  Promise = require("bluebird");

  request = require("request-promise");

  retry = require("bluebird-retry");

  NodeCache = require("node-cache");

  translatedCache = new NodeCache({
    stdTTL: 0,
    checkperiod: 0
  });

  MERCADOLIBRE_API_CORE_URL = process.env.MERCADOLIBRE_API_CORE_URL || "https://apps.producteca.com/mercadolibre-api";

  MERCADOLIBRE_API_MASTER_TOKEN = process.env.MERCADOLIBRE_API_MASTER_TOKEN;

  module.exports = UserIdTranslator = function () {
    function UserIdTranslator() {
      _classCallCheck(this, UserIdTranslator);

      this.translate = this.translate.bind(this);
      this.getCompanyId = this.getCompanyId.bind(this);
      this._setInCache = this._setInCache.bind(this);
      this._translateUserId = this._translateUserId.bind(this);
      this.translatedCache = translatedCache;
      this.translate = this.translate.bind(this);
    }

    _createClass(UserIdTranslator, [{
      key: "translate",
      value: function translate(userId) {
        if (!MERCADOLIBRE_API_MASTER_TOKEN) {
          return Promise.resolve(null);
        }
        return this.getCompanyId(userId);
      }
    }, {
      key: "getCompanyId",
      value: function getCompanyId(userId) {
        var companyId;
        companyId = this.translatedCache.get(userId);
        if (companyId) {
          return Promise.resolve(companyId);
        } else {
          return this._translateUserId(userId);
        }
      }
    }, {
      key: "_setInCache",
      value: function _setInCache(userId, userInfo) {
        var success;
        success = this.translatedCache.set(userId, userInfo);
        if (success) {
          console.log("UserId %s ===> %s was stored in cache successfully", userId, JSON.stringify(userInfo));
        }
        return Promise.resolve(success);
      }
    }, {
      key: "_translateUserId",
      value: function _translateUserId(userId) {
        var _this = this;

        console.log("Making request to translate", userId);
        return retry(function () {
          return request.get({
            url: MERCADOLIBRE_API_CORE_URL + "/users/me",
            json: true,
            qs: {
              authenticationType: "mercadolibre"
            },
            auth: {
              user: "" + userId,
              password: MERCADOLIBRE_API_MASTER_TOKEN
            }
          }).promise();
        }).then(function (userInformation) {
          return {
            app: userInformation.app,
            companyId: userInformation.tenantId || userInformation.companyId
          };
        }).tap(function (_ref) {
          var companyId = _ref.companyId;

          return console.log("UserId translated %s ==> %s", userId, companyId);
        }).catch(function (reason) {
          if (_.includes([401, 500], reason.statusCode)) {
            return "Unknown";
          }
          throw reason;
        }).tap(function (companyId) {
          return _this._setInCache(userId, companyId);
        });
      }
    }]);

    return UserIdTranslator;
  }();
}).call(undefined);