"use strict";

// Generated by CoffeeScript 2.7.0
(function () {
  var DeadLetterSucceeded, DelayObserver, DidLastRetry, _, create;

  _ = require("lodash");

  DelayObserver = require("../observers/delay.observer");

  DeadLetterSucceeded = require("../observers/deadLetterSucceeded.observer");

  DidLastRetry = require("../observers/didLastRetry.observer");

  create = function create(Type) {
    return function (opts) {
      var subscription, topic;
      topic = opts.topic;
      subscription = opts.subscription;

      return new Type(_(opts).omit(["topic", "subscription"]).defaults({
        path: topic + "/" + subscription
      }).value());
    };
  };

  module.exports = {
    newNotification: function newNotification(_ref) {
      var bindingData = _ref.context.bindingData,
          message = _ref.message;

      return {
        message: _.omit(message, "Sent"),
        meta: {
          messageId: bindingData.messageId,
          insertionTime: bindingData.enqueuedTimeUtc,
          dequeueCount: bindingData.deliveryCount,
          properties: bindingData.userProperties || bindingData.properties
        },
        type: "sb"
      };
    },
    delayObserver: create(DelayObserver),
    deadLetterSucceeded: create(DeadLetterSucceeded),
    didLastRetry: create(DidLastRetry)
  };
}).call(undefined);